/*
Copyright 2020 The Tekton Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/tektoncd/operator/pkg/apis/operator/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TektonDashboardLister helps list TektonDashboards.
// All objects returned here must be treated as read-only.
type TektonDashboardLister interface {
	// List lists all TektonDashboards in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.TektonDashboard, err error)
	// Get retrieves the TektonDashboard from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.TektonDashboard, error)
	TektonDashboardListerExpansion
}

// tektonDashboardLister implements the TektonDashboardLister interface.
type tektonDashboardLister struct {
	indexer cache.Indexer
}

// NewTektonDashboardLister returns a new TektonDashboardLister.
func NewTektonDashboardLister(indexer cache.Indexer) TektonDashboardLister {
	return &tektonDashboardLister{indexer: indexer}
}

// List lists all TektonDashboards in the indexer.
func (s *tektonDashboardLister) List(selector labels.Selector) (ret []*v1alpha1.TektonDashboard, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TektonDashboard))
	})
	return ret, err
}

// Get retrieves the TektonDashboard from the index for a given name.
func (s *tektonDashboardLister) Get(name string) (*v1alpha1.TektonDashboard, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("tektondashboard"), name)
	}
	return obj.(*v1alpha1.TektonDashboard), nil
}
