/*
Copyright 2020 The Tekton Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/tektoncd/operator/pkg/apis/operator/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TektonResultLister helps list TektonResults.
// All objects returned here must be treated as read-only.
type TektonResultLister interface {
	// List lists all TektonResults in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.TektonResult, err error)
	// Get retrieves the TektonResult from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.TektonResult, error)
	TektonResultListerExpansion
}

// tektonResultLister implements the TektonResultLister interface.
type tektonResultLister struct {
	indexer cache.Indexer
}

// NewTektonResultLister returns a new TektonResultLister.
func NewTektonResultLister(indexer cache.Indexer) TektonResultLister {
	return &tektonResultLister{indexer: indexer}
}

// List lists all TektonResults in the indexer.
func (s *tektonResultLister) List(selector labels.Selector) (ret []*v1alpha1.TektonResult, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.TektonResult))
	})
	return ret, err
}

// Get retrieves the TektonResult from the index for a given name.
func (s *tektonResultLister) Get(name string) (*v1alpha1.TektonResult, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("tektonresult"), name)
	}
	return obj.(*v1alpha1.TektonResult), nil
}
